/*
 * This Source Code Form is subject to the terms of the Mozilla Public
 * License, v. 2.0. If a copy of the MPL was not distributed with this
 * file, You can obtain one at https://mozilla.org/MPL/2.0/.
 */

#include "CubesExampleApp.hpp"
#include "Scene/Scene.hpp"
#include "Scene/Shader/Shader.hpp"
#include "Scene/Geometry.hpp"
#include "Scene/GeometryFactory.hpp"
#include "Scene/Material.hpp"
#include "Scene/Vertex.hpp"
#include "Scene/SimpleDrawable.hpp"
#include "Scene/UI/PerformanceInfo.hpp"
#include "Input/InputManager.hpp"
#include "Host/GraphicsAppManager.hpp"
#include "Math/Math.hpp"
#include "Base/EngineConfiguration.hpp"
#include "Controller/FreeCamCameraController.hpp"

#pragma clang diagnostic push
#pragma ide diagnostic ignored "cert-msc50-cpp"
#pragma ide diagnostic ignored "cppcoreguidelines-narrowing-conversions"


uint32_t GEOS = 3000, OBJECTS = 10000, DYNAMIC = 1000;

namespace OpenVulkano
{
	using namespace Scene;
	using namespace Input;
	using namespace Math;

	class CubesExampleAppImpl final : public CubesExampleApp
	{
		OpenVulkano::Scene::Scene scene;
		PerspectiveCamera cam;
		OpenVulkano::FreeCamCameraController camController;
		Material mat;
		Shader shader;
		std::vector<SimpleDrawable> drawablesPool;
		std::vector<Node> nodesPool;
		Vector3f_SIMD position = {0, 0, -10};
		std::vector<Geometry> m_geos;

		OpenVulkano::Scene::UI::SimpleUi m_ui;
		std::shared_ptr<OpenVulkano::Scene::UI::PerformanceInfo> m_perfInfo;

	public:
		void Init() override
		{
			auto engineConfig = OpenVulkano::EngineConfiguration::GetEngineConfiguration();
			engineConfig->SetNumThreads(4);
			engineConfig->SetPreferFramebufferFormatSRGB(false);

			std::srand(1); // Fix seed for random numbers
			scene.Init();
			cam.Init(70, 16, 9, 0.1f, 100);
			scene.SetCamera(&cam);
			shader.AddShaderProgram(OpenVulkano::ShaderProgramType::VERTEX, "Shader/basic");
			shader.AddShaderProgram(OpenVulkano::ShaderProgramType::FRAGMENT, "Shader/basic");
			shader.AddVertexInputDescription(OpenVulkano::Vertex::GetVertexInputDescription());
			drawablesPool.resize(GEOS);
			m_geos.reserve(GEOS);
			for (uint32_t i = 0; i < GEOS; i++)
			{
				m_geos.push_back(GeometryFactory::MakeCube(
													std::rand() % 1000 / 1000.0f + 0.01f, std::rand() % 1000 / 1000.0f + 0.01f,
													std::rand() % 1000 / 1000.0f + 0.01f,
													Vector4f((std::rand() % 255) / 255.0f, (std::rand() % 255) / 255.0f, (std::rand() % 255) / 255.0f, 1)));
				drawablesPool[i].Init(&shader, &m_geos[i], &mat);
			}
			nodesPool.resize(OBJECTS);
			for (uint32_t i = 0; i < OBJECTS; i++)
			{
				nodesPool[i].Init();
				scene.GetRoot()->AddChild(&nodesPool[i]);
				if (i < DYNAMIC) nodesPool[i].SetUpdateFrequency(UpdateFrequency::Always);
				nodesPool[i].AddDrawable(&drawablesPool[std::rand() % GEOS]);
				nodesPool[i].SetMatrix(Math::Utils::translate(glm::mat4x4(1), Vector3f((std::rand() % 10000) / 1000.0f - 5, (std::rand() % 10000) / 1000.0f - 5, (std::rand() % 10000) / 1000.0f - 5)));
			}

			GetGraphicsAppManager()->GetRenderer()->SetScene(&scene);

			camController.Init(&cam);
			camController.SetDefaultKeybindings();
			camController.SetPosition({0, 0, 10});

			std::shared_ptr<OpenVulkano::Scene::UI::PerformanceInfo> m_perfInfo = std::make_shared<OpenVulkano::Scene::UI::PerformanceInfo>();
			m_ui.AddElement(m_perfInfo);
			GetGraphicsAppManager()->GetRenderer()->SetActiveUi(&m_ui);
		}

		void Tick() override
		{
			for (uint32_t i = 0; i < DYNAMIC; i++)
			{
				nodesPool[i].SetMatrix(glm::translate(glm::mat4x4(1), glm::vec3((std::rand() % 10000) / 1000.0f - 5, (std::rand() % 10000) / 1000.0f - 5, (std::rand() % 10000) / 1000.0f - 5)));
			}

			camController.Tick();
		}

		void Close() override
		{}
	};

	IGraphicsApp* CubesExampleApp::Create()
	{
		return new CubesExampleAppImpl();
	}

	std::unique_ptr<IGraphicsApp> CubesExampleApp::CreateUnique()
	{
		return std::make_unique<CubesExampleAppImpl>();
	}

}

#pragma clang diagnostic pop
#pragma clang diagnostic pop